<?php
// additional functions for myGallery

//#################################################################
function getmygallerys($myoffest=0,$myrow=0) {

	global $table_prefix, $wpdb;

	$thegallerys = $wpdb->get_results('SELECT * FROM ' . $table_prefix . 'mygallery');
	
	return $thegallerys;

}
//#################################################################

function getgalleryname($mygalleryid) {
	
	global $table_prefix, $wpdb;
	
	$mygalleryname=$wpdb->get_var('SELECT name FROM '.$table_prefix.'mygallery WHERE id ="'.$mygalleryid.'"');
	return $mygalleryname;
}
//#################################################################

function getgallerypageid($mygalleryid) {
	
	global $table_prefix, $wpdb;
	
	$mygallerypage_id=$wpdb->get_var('SELECT pageid FROM '.$table_prefix.'mygallery WHERE id ="'.$mygalleryid.'"');
	if ($mygallerypage_id=='0') $mygallerypage_id='';
	return $mygallerypage_id;
}
//#################################################################

function getgallerydescrip($mygalleryid) {
	
	global $table_prefix, $wpdb;
	
	$mygallery_descrip=$wpdb->get_var('SELECT galdescrip FROM '.$table_prefix.'mygallery WHERE id ="'.$mygalleryid.'"');
	return $mygallery_descrip;
}
//#################################################################

function getpreviewpic($mygalleryid) {
	
	global $table_prefix, $wpdb;
	
	$mygallery_previewpic=$wpdb->get_var('SELECT previewpic FROM '.$table_prefix.'mygallery WHERE id ="'.$mygalleryid.'"');
	return $mygallery_previewpic;
}
//#################################################################

function getpicturepath($mypicture_id) {
	
	global $table_prefix, $wpdb;
	
	$mypicturepath=$wpdb->get_var('SELECT picturepath FROM '.$table_prefix.'mypictures WHERE '.$table_prefix.'mypictures.id = '.$mypicture_id);
	return $mypicturepath;
}
//#################################################################

function getgallerylongname($mygalleryid) {
	
	global $table_prefix, $wpdb;
	
	$mylongname=$wpdb->get_var('SELECT longname FROM '.$table_prefix.'mygallery WHERE id ="'.$mygalleryid.'"');
	return $mylongname;
}
//#################################################################

function getgalleryexclude($mygalleryid) {
	  global $table_prefix, $wpdb;
	  
	  $myexclude=$wpdb->get_var('SELECT excludegal FROM '.$table_prefix.'mygallery WHERE id ="'.$mygalleryid.'"');
	  return $myexclude;
}
//#################################################################

function getmygallerysnoex() {
	
	// get only those gallerys, wich are not exclude form overview
	
	global $table_prefix, $wpdb;

	$thegallerys = $wpdb->get_results('SELECT * FROM ' . $table_prefix . 'mygallery WHERE excludegal IS NULL OR excludegal=0');
	return $thegallerys;

}
//#################################################################

function getalttitle($mypicture_id) {
	
	global $table_prefix, $wpdb;
	
	$myalttitle=$wpdb->get_var('SELECT alttitle FROM '.$table_prefix.'mypictures WHERE '.$table_prefix.'mypictures.id = '.$mypicture_id);
	return $myalttitle;
}
//#################################################################

function getstoredpics($myid) {
	
	global $table_prefix, $wpdb;
	
	$finalpics=array();
	
	$thepictures = $wpdb->get_results('SELECT picturepath FROM '.$table_prefix.'mypictures,'.$table_prefix.'mygprelation,'.$table_prefix.'mygallery WHERE '.$table_prefix.'mypictures.id = '.$table_prefix. 'mygprelation.pid AND '.$table_prefix.'mygprelation.gid = '.$myid.' AND '.$table_prefix.'mygallery.id ='.$myid);
	if (is_array($thepictures)) {
		foreach ($thepictures as $tmp) {
			array_push($finalpics, $tmp->picturepath);
			
		}
	}
	return $finalpics;
	
}
//#################################################################

function myinlinepicture($mypicture_id,$my_align,$my_popoption,$my_scaleorethumb)  {
	
	global $table_prefix, $wpdb, $myurl,$wp_rewrite, $mg_options;
	
	// read database
	
	$result=$wpdb->get_row('SELECT * FROM '.$table_prefix.'mypictures,'.$table_prefix.'mygprelation,'.$table_prefix.'mygallery WHERE '.$table_prefix.'mypictures.id = '.$mypicture_id.' AND '.$table_prefix.'mygprelation.pid = '.$mypicture_id.' AND '.$table_prefix.'mygallery.id ='.$table_prefix.'mygprelation.gid' );
	
	// trim align option and set img align
	
	$my_align = ltrim($my_align,',');
	
	switch ($my_align) {
		
		case 'left': $float='myinlinepictureleft';
		break;
		
		case 'right': $float='myinlinepictureright';
		break;
		
		case 'leftclear': 
		$flag='<br style="clear:both"/>';
		$float='myinlinepictureleftclear';
		break;
		
		case 'rightclear': 
		$flag='<br style="clear:both"/>';
		$float='myinlinepicturerightclear';
		break;
		
		default: 
		$flag='<br style="clear:both"/>';
		$float='myinlinepicture';
	}
	
	// trim scaleoption and check if the user want's a thumbnail or a scaled picture
	
	$my_scaleorethumb= ltrim($my_scaleorethumb,',');
	
	if ($my_scaleorethumb=='thumb') {
		$prefix='/tumbs/tmb_';
	}
	
	else {
		
		settype($my_scaleorethumb, "integer");
	}
	
	// set width and height of the picture 
	
	$my_extension = strtolower(end(explode('.', $result->picturepath)));
	
	switch ($my_extension) {
		
		case "jpg": $mybigimg = imagecreatefromjpeg(ABSPATH.$mg_options[gallerybasepath].$result->name.'/'.$prefix.$result->picturepath);
		break;
		
		case "png": $mybigimg = imagecreatefrompng(ABSPATH.$mg_options[gallerybasepath].$result->name.'/'.$prefix.$result->picturepath);
		break;
		
		case "gif": $mybigimg = imagecreatefromgif(ABSPATH.$mg_options[gallerybasepath].$result->name.'/'.$prefix.$result->picturepath);
		break;	
	}
	
	
	if (is_int($my_scaleorethumb) AND $my_scaleorethumb >0) {
		$mybigimg_width=$my_scaleorethumb;
		$mybigimg_height = (int) (($my_scaleorethumb/ imageSX($mybigimg)) * imageSY($mybigimg));
	}
	
	else {
		$mybigimg_width = imageSX($mybigimg);
		$mybigimg_height = imageSY($mybigimg);		
	}
	
	imagedestroy($mybigimg);
	
	// include picture description
	
	if ($result->description AND $mg_options[inlinepicdesc]) {
		$mydescription='<div class="myinlinepicdescription"><span>'.$result->description.'</span></div>';
	}
	// trim reference option and set reference 
	
	$my_popoption=ltrim($my_popoption,',');
	
	if ($my_popoption=='fullscreen') {
		
		if ($mg_options[lightboxjs]) $mylightboxref='rel="lightbox"';
		$fullref_pre='<a '.$mylightboxref.' href="'.$myurl.$result->name.'/'.$result->picturepath.'"  title="'.$result->alttitle.'">';
		$fullref_post='</a>';
	}
	else if (($my_popoption=='gal') AND($result->pageid) ) {
		
		$myreference=get_permalink($result->pageid); 
		
		if ($wp_rewrite->using_permalinks()) {
			$myreference=$myreference.'?picture_id=';
		}
		else {
			$myreference=$myreference.'&picture_id=';
		}
		
		$fullref_pre='<a href="'.$myreference.$result->pid.'">';
		$fullref_post='</a>';
}	
	// build the final string

	$my_string='<div class="'.$float.'" style="width:'.$mybigimg_width.'px"><div class="myinlineborder"  style="width:'.$mybigimg_width.'px">'.$fullref_pre.'<img class="myinlinepictureimg" src="'.$myurl.$result->name.'/'.$prefix.$result->picturepath.'" alt="'.$result->alttitle.'" title="'.$result->alttitle.'" width="'.$mybigimg_width.'" height="'.$mybigimg_height.'"  />'.$fullref_post.'</div>'.$mydescription.'</div>'.$flag;
	
	return $my_string;
}
//#################################################################

function galleryexists($mydirectory) {
	
	global $table_prefix, $wpdb;
	if ($mydirectory) {
		$mygalleryid=$wpdb->get_var('SELECT id FROM '.$table_prefix.'mygallery WHERE name ="'.$mydirectory.'"');
	}
	
	return $mygalleryid;
}

//#################################################################

function nasty_p_filter($mystring) {

	$search = "/<p>(|\s)(\[mygal=\w+\]|\[mygallistgal\]|\[myginpage=\w+\]|\[inspic=(\d+)(|,\w+|,)(|,fullscreen|,gal|,)(|,thumb|,\d+)\])(|\s)<\/p>/";
	$replace = "$2";
	$mystring = preg_replace ($search, $replace, $mystring);
	
	$search="/<p>(|\s)(\[mygal=\w+\]|\[mygallistgal\]|\[myginpage=\w+\]|\[inspic=(\d+)(|,\w+|,)(|,fullscreen|,gal|,)(|,thumb|,\d+)\])(|\s||<br \/>\s)(.*)(|\s)<\/p>/";
	$replace = "$2<p>$8</p>";
	$mystring = preg_replace ($search, $replace, $mystring);
	
	$search="/<p>(.*|.*\n)(\[mygal=\w+\]|\[mygallistgal\]|\[myginpage=\w+\]|\[inspic=(\d+)(|,\w+|,)(|,fullscreen|,gal|,)(|,thumb|,\d+)\])(|\s)(.*|.*\n.*\n)(|\s)<\/p>/";
	$replace = "<p>$1</p>$2<p>$8</p>";
	$mystring = preg_replace ($search, $replace, $mystring);
	
	$search="/<p>(.*|.*\n)(\[mygal=\w+\]|\[mygallistgal\]|\[myginpage=\w+\]|\[inspic=(\d+)(|,\w+|,)(|,fullscreen|,gal|,)(|,thumb|,\d+)\])(|\s)<\/p>/";
	$replace = "<p>$1</p>$2";
	$mystring = preg_replace ($search, $replace, $mystring);
	
	$search="/<p>(|\s)(\[mygal=\w+\]|\[mygallistgal\]|\[myginpage=\w+\]|\[inspic=(\d+)(|,\w+|,)(|,fullscreen|,gal|,)(|,thumb|,\d+)\])(.*)(\s<br \/>|<br \/>)/";
	// changed on 15.02.2006 - <br /> causes problems $replace = "$2<br /><p>$7";  //modified on 24.01.2006 18:43 maybe the <br /> is not usefull
	$replace = "$2<p>$7";
	$mystring = preg_replace ($search, $replace, $mystring);
	
	return $mystring;
	
}

//#################################################################

function spreedgallerytopages($mypage=0) {
	
	global $table_prefix, $wpdb,$mg_options,$wp_rewrite;
	
	if ( $wp_rewrite->using_permalinks() ) {
		$mygalleryavigation=get_permalink().'?galpage=';
	}
	else {
		$mygalleryavigation=get_permalink().'&galpage=';
	}
	
	if ($mg_options[excludeoverview]) {
		$mycount = $wpdb->get_var('SELECT COUNT(id) FROM ' . $table_prefix . 'mygallery WHERE excludegal IS NULL OR excludegal=0');
		$myexclude=' WHERE excludegal IS NULL OR excludegal=0';
	}
	
	else {
		$mycount = $wpdb->get_var('SELECT COUNT(id) FROM ' . $table_prefix . 'mygallery');
	}
	
	if ($mg_options[gal_sortorder]==1) $mysort='id';
	if ($mg_options[gal_sortorder]==2) $mysort='name';
	if ($mg_options[gal_sortorder]==3) $mysort=' gallsortnr';
	if ($mg_options[gal_sortascdes]==2) $sortorder=' DESC';
	
	if ((($mg_options[galpagesize]*($mypage-1))< $mycount) AND ($mypage > 0)) {
		
		$mygallerys = $wpdb->get_results('SELECT * FROM ' . $table_prefix . 'mygallery'.$myexclude.' ORDER BY '.$table_prefix.'mygallery.'.$mysort.$sortorder .' LIMIT '.($mg_options[galpagesize]*($mypage-1)).','.$mg_options[galpagesize]);
		
		if (($mg_options[galpagesize]*$mypage) < $mycount) {
			$myfor='<div class="galleryfor"><a href="'.$mygalleryavigation.($mypage+1).'" title="'.__('forward', 'myGallery').'">'.$mg_options[navigationfor].'</a></div>';
		}
		
		if ($mypage > 1) {
			$myback='<div class="galleryback"><a href="'.$mygalleryavigation.($mypage-1).'" title="'.__('back', 'myGallery').'">'.$mg_options[navigationback].'</a></div>';
		}
		
		$mynavigation='<div class="gallerynav">'.$myback.$myfor.'</div>';
	}
	else {
		$mygallerys = $wpdb->get_results('SELECT * FROM ' . $table_prefix . 'mygallery'.$myexclude.' ORDER BY '.$table_prefix.'mygallery.'.$mysort.$sortorder );
	}
	

	return  array ($mygallerys, $mynavigation);
	
}
//#################################################################

function generatethumbnail($mypath, $stored_file, $shrinkfit=0) {
	
	$mg_options=get_option('mygalleryoptions');
	
	// properties of thumbnails
	
	switch ($mg_options[scalethumb]) {
		
		case 1: $tmb_width=$mg_options[tumbwidth_a];
		break;
		
		case 2: $tmb_width=$mg_options[tumbwidth_b];
		break;
		
		default: $tmb_width=$mg_options[tumbwidth];
		
	}
	
	if (!$tmb_width) $tmb_width=100; // set aus default
	
	$tmb_height=$mg_options[tumbheight];
	$quality=100;
	$prefix='tmb_';
	
	if (!$tmb_height) $tmb_height=75; // set aus default
	
	
	$my_extension = strtolower(end(explode('.', $stored_file)));
	
	switch ($my_extension) {
		
		case "jpg": $myimg = imagecreatefromjpeg("$mypath/$stored_file");
		break;
		
		case "png": $myimg = imagecreatefrompng("$mypath/$stored_file");
		break;
		
		case "gif": $myimg = imagecreatefromgif("$mypath/$stored_file");
		break;
		
	}
	$myimg_width = imageSX($myimg);
	$myimg_height = imageSY($myimg);
	
	if ($mg_options[scalethumb]==1) {
		
		// check if picture is in potrait format
		
		if (($myimg_height > $myimg_width) AND ($mg_options[preserve]==1)) {
			$tmb_height=$tmb_width;
			$new_tmb_width = (int) (($tmb_height / $myimg_height) * $myimg_width);
			if ($my_extension=='gif') {
				$new_img = imagecreate($new_tmb_width,$tmb_height);
			}
			else {
				$new_img = imagecreatetruecolor($new_tmb_width,$tmb_height);
			}
			imagecopyresampled($new_img, $myimg, 0, 0, 0, 0, $new_tmb_width, $tmb_height, $myimg_width, $myimg_height);
			
		}
		else {
			$tmb_height = (int) (($tmb_width / $myimg_width) * $myimg_height);
			if ($my_extension=='gif') {
				$new_img = imagecreate($tmb_width,$tmb_height);
			}
			else {
				$new_img = imagecreatetruecolor($tmb_width,$tmb_height);
			}
			imagecopyresampled($new_img, $myimg, 0, 0, 0, 0, $tmb_width, $tmb_height, $myimg_width, $myimg_height);
			
		}
		
	}
	else if ($mg_options[scalethumb]==2){
		
		$tmb_x=(int) (($myimg_width/2)-($tmb_width/2));
		$tmb_y=(int) (($myimg_height/2)-($tmb_width/2));
		
		if ($my_extension=='gif') {
			$new_img = imagecreate($tmb_width,$tmb_width);
		}
		else {
			$new_img = imagecreatetruecolor($tmb_width,$tmb_width);
		}
		
		imagecopy ( $new_img,$myimg,0,0,$tmb_x,$tmb_y,$tmb_width,$tmb_width);
		
	}
	else {
		
		// check if picture is in potrait format
		
		if (($myimg_height > $myimg_width) AND ($mg_options[preserve]==1)) {
			if ($my_extension=='gif') {
				$new_img = imagecreate($tmb_height,$tmb_width);
			}
			else {
				$new_img = imagecreatetruecolor($tmb_height,$tmb_width);
			}
			
			imagecopyresampled($new_img, $myimg, 0, 0, 0, 0, $tmb_height,$tmb_width, $myimg_width, $myimg_height);
		}
		else {
			if ($my_extension=='gif') {
				$new_img = imagecreate($tmb_width,$tmb_height);
			}
			else {
				$new_img = imagecreatetruecolor($tmb_width,$tmb_height);
			}
			
			imagecopyresampled($new_img, $myimg, 0, 0, 0, 0, $tmb_width, $tmb_height, $myimg_width, $myimg_height);
		}
		
		
	}
	
	switch ($my_extension) {
		
		case "jpg": imagejpeg($new_img, "$mypath/tumbs/$prefix$stored_file",$quality);
		break;
		
		case "png": imagepng($new_img, "$mypath/tumbs/$prefix$stored_file",$quality);
		break;
		
		case "gif": imagegif($new_img, "$mypath/tumbs/$prefix$stored_file",$quality);
		break;
		
	}
	@chmod ("$mypath/tumbs/$prefix$stored_file", file_permissions) or die ('<div class="updated"><p><strong>'.__('Unable to change permissions for picture ', 'myGallery').$mypath.'/tumbs/'.$prefix.$stored_file.'!</strong></p></div>');
	
	
	// shrinks pictures to fit into theme if option was set
	
	if ($shrinkfit) {
		
		// check if picture is in potrait format
		
		if (($myimg_height > $myimg_width) AND ($mg_options[preserve]==1)) {
			$new_height=$mg_options[shrinkwidth];
			$new_width = (int) (($new_height / $myimg_height) * $myimg_width);
		}
		else {
			$new_width=$mg_options[shrinkwidth];
			$new_height = (int) (($new_width / $myimg_width) * $myimg_height);
		}
		
		if ($my_extension=='gif') {
			$new_img = imagecreate($new_width,$new_height);
		}
		else {
			$new_img = imagecreatetruecolor($new_width,$new_height);
		}
		
		imagecopyresampled($new_img, $myimg, 0, 0, 0, 0, $new_width, $new_height, $myimg_width, $myimg_height);
		
		switch ($my_extension) {
			
			case "jpg":imagejpeg($new_img, "$mypath/$stored_file",$quality);
			break;
			
			case "png": imagepng($new_img, "$mypath/$stored_file",$quality);
			break;
			
			case "gif": imagegif($new_img, "$mypath/$stored_file",$quality);
			break;
			
		}
		
		imagedestroy($new_img);
	}
	
	imagedestroy($myimg);	
}

//#################################################################

function getexifinfo($myimgpath){
	
	$mg_exifoptions=get_option('mygexifoptions');
	$mg_options = get_option('mygalleryoptions');
	$exif = @exif_read_data($myimgpath, 0, true);
	
	if ($mg_options[language]) load_textdomain('myGallery', myGalleryPath.'/languages/'.$mg_options[language].'.mo');
	
	$exposureprogram= array (0=>__('Unidentified', 'myGallery'), 1=>__('Manual', 'myGallery'), 2=> __('Normal', 'myGallery'), 3=>__('Aperture priority', 'myGallery'), 4=>__('Shutter priority', 'myGallery'),5=>__('Creative', 'myGallery'),6=>__('Action', 'myGallery'),7=>__('Portrait mode', 'myGallery'),8=>__('Landscape mode', 'myGallery'));
	$myexifinfo='<div class="exifmetalabel">'.__('Metadata', 'myGallery').'</div>';
	$myexifinfo=$myexifinfo.'<div class="exifbox">';
	
	if ($mg_exifoptions[make] AND ($exif['IFD0']['Make'] OR !$mg_exifoptions[exifskipempty])) {
		$class = ('one' == $class) ? 'two' : 'one';
		$myexifinfo=$myexifinfo.'<div class="exiflabel'.$class.'">'.__('Make', 'myGallery').': <span class="exifdata'.$class.'">'.$exif['IFD0']['Make'].'</span></div>';
	}
	if ($mg_exifoptions[model] AND ($exif['IFD0']['Model'] OR !$mg_exifoptions[exifskipempty])) {
		$class = ('one' == $class) ? 'two' : 'one';
		$myexifinfo=$myexifinfo.'<div class="exiflabel'.$class.'">'.__('Model', 'myGallery').': <span class="exifdata'.$class.'">'.$exif['IFD0']['Model'].'</span></div>';
	}
	if ($mg_exifoptions[exposuretime] AND ($exif['EXIF']['ExposureTime'] OR !$mg_exifoptions[exifskipempty])) {
		$class = ('one' == $class) ? 'two' : 'one';
		$myexifinfo=$myexifinfo.'<div class="exiflabel'.$class.'">'.__('Exposure Time', 'myGallery').': <span class="exifdata'.$class.'">'.$exif['EXIF']['ExposureTime'].'</span></div>';	
	}
	if ($mg_exifoptions[shutterspeed] AND ($exif['EXIF']['ShutterSpeedValue'] OR !$mg_exifoptions[exifskipempty])) {
		$class = ('one' == $class) ? 'two' : 'one';
		$myexifinfo=$myexifinfo.'<div class="exiflabel'.$class.'">'.__('Shutter Speed', 'myGallery').': <span class="exifdata'.$class.'">'.$exif['EXIF']['ShutterSpeedValue'].'</span></div>';
	}
	if ($mg_exifoptions[afnumber] AND ($exif['COMPUTED']['ApertureFNumber'] OR !$mg_exifoptions[exifskipempty])) {
		$class = ('one' == $class) ? 'two' : 'one';
		$myexifinfo=$myexifinfo.'<div class="exiflabel'.$class.'">'.__('Aperture FNumber', 'myGallery').': <span class="exifdata'.$class.'">'.$exif['COMPUTED']['ApertureFNumber'].'</span></div>';
	}
	if ($mg_exifoptions[focall] AND ($exif['EXIF']['FocalLength'] OR !$mg_exifoptions[exifskipempty])) {
		$class = ('one' == $class) ? 'two' : 'one';
		$myexifinfo=$myexifinfo.'<div class="exiflabel'.$class.'">'.__('Focal Length', 'myGallery').': <span class="exifdata'.$class.'">'.$exif['EXIF']['FocalLength'].'</span></div>';
	}
	if ($mg_exifoptions[iso]  AND ($exif['EXIF']['ISOSpeedRatings'] OR !$mg_exifoptions[exifskipempty])) {
		$class = ('one' == $class) ? 'two' : 'one';
		$myexifinfo=$myexifinfo.'<div class="exiflabel'.$class.'">'.__('ISO Speed Ratings', 'myGallery').': <span class="exifdata'.$class.'">'.$exif['EXIF']['ISOSpeedRatings'].'</span></div>';
	}
	if ($mg_exifoptions[datime] AND ($exif['IFD0']['DateTime'] OR !$mg_exifoptions[exifskipempty])) {
		$class = ('one' == $class) ? 'two' : 'one';
		$myexifinfo=$myexifinfo.'<div class="exiflabel'.$class.'">'.__('Date and Time', 'myGallery').': <span class="exifdata'.$class.'">'.$exif['IFD0']['DateTime'].'</span></div>';
	}
	$tmp_ep=$exif['EXIF']['ExposureProgram'];
	if (array_key_exists($tmp_ep, $exposureprogram)) $tpm_epv=$exposureprogram[$tmp_ep];
	
	if ($mg_exifoptions[expro] AND ($tpm_epv OR !$mg_exifoptions[exifskipempty])) {
		$class = ('one' == $class) ? 'two' : 'one';
		$myexifinfo=$myexifinfo.'<div class="exiflabel'.$class.'">'.__('Exposure Program', 'myGallery').': <span class="exifdata'.$class.'">'.$tpm_epv.'</span></div>';
	}
	$tmp_flash=getbit(decbin($exif['EXIF']['Flash']),0);
	if ($tmp_flash=='0') { 
		$tmp_flashvalue=__('no', 'myGallery');
	}
	else if ($tmp_flash=='1') {
		$tmp_flashvalue=__('yes', 'myGallery');
	}
	if ($mg_exifoptions[flash] AND ($tmp_flashvalue OR !$mg_exifoptions[exifskipempty])) {
		$class = ('one' == $class) ? 'two' : 'one';
		$myexifinfo=$myexifinfo.'<div  class="exiflabel'.$class.'">'.__('Flash', 'myGallery').': <span  class="exifdata'.$class.'">'.$tmp_flashvalue.'</span></div>';
	}
	$myexifinfo=$myexifinfo.'</div>';
	
	return $myexifinfo;
}
//#################################################################

function getbit($bits,$i){
 
 if (($i <= strlen($bits)-1) && ($i >= 0)) {
  $bit = $bits[strlen($bits)-1-$i];
 } 
 return $bit;
}

//#################################################################

function getgalleryordernr($mygalleryid) {
	
	global $table_prefix, $wpdb;
	
	$myordernr=$wpdb->get_var('SELECT gallsortnr FROM '.$table_prefix.'mygallery WHERE id ="'.$mygalleryid.'"');
	return $myordernr;
}
//#################################################################

function mytextpiclink($mypicture_id,$mytext) {
	
	global $table_prefix, $wpdb, $myurl;
	
	// read database
	
	$result=$wpdb->get_row('SELECT * FROM '.$table_prefix.'mypictures,'.$table_prefix.'mygprelation,'.$table_prefix.'mygallery WHERE '.$table_prefix.'mypictures.id = '.$mypicture_id.' AND '.$table_prefix.'mygprelation.pid = '.$mypicture_id.' AND '.$table_prefix.'mygallery.id ='.$table_prefix.'mygprelation.gid' );
	
	$myrefstring='<a rel="lightbox" href="'.$myurl.$result->name.'/'.$result->picturepath.'"  title="'.$result->alttitle.'">'.$mytext.'</a>';
	
	return $myrefstring;
}


//#################################################################
?>
